@echo off
cls
:: HOLIDAYS.BAT
:: If user specifies a year as parm1, use it

:: -------------------------------------------------------
:: REVISION HISTORY
:: 2001-11-06 Remie Doren revised it, to calculate Easter through 2100
:: 1997 Apr 22 revised to use /Q with /FE /J
:: 1994 Nov 06 to use new /J parm in version 8.8
:: 1996 Jan 26 to correct a mis-spelling
:: -------------------------------------------------------

set year=%1
If Not (%year%)==() Goto GetYrEnd

:: get name of this batch file, in upper case
FDATE /fupper /q%0 /v

:: show title between two lines of bars
FDATE /fe /J"L79" /Q
FDATE /fe /J"C 79" /Q"%FDATE%"
FDATE /fe /J"L79" /Q

:GetYr
echo.
echo Please enter the year for which you want holidays calculated,
FDATE /fget /q"or press ENTER for current year > " /vyear
If Not (%year%)==() Goto GetYrEnd

:: get current year
FDATE /Ff /At /Occyy /vyear

:GetYrEnd

:: pad year to left with zeroes, to make sure it is 4 bytes long
FDATE /Fe /Q%year%  /JR04 /vyear

echo.
:: check for validity of year parm (%1)
FDATE /Fv /A01-01-%year% >nul
If errorlevel 1 Echo Value [%year%] is not a valid year.
If errorlevel 1 Goto Endit

:: --------------------------------------------------------
:: Determine If year is a leapyear
:: --------------------------------------------------------
FDATE /Ff /A01-01-%year% /Oly /vLY

cls
echo 
If (%LY%)==(0) Echo                   EVENTS IN %YEAR%
If (%LY%)==(1) Echo                   EVENTS IN %YEAR%         Note: %year% is a leap year
echo To print the calendar, press SHIFT+PRINTSCREEN to print each screen.
echo 
FDATE /Fe /J"L.50" /Vtitle /Q"New Year's Day"
FDATE /Ff   /A01-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle /Q"Epiphany"
FDATE /Ff  /A01-06-%year%  /P"%title% "

FDATE /Fe /J"L.50" /Vtitle /Q"Martin Luther King, Jr. Day"
FDATE /Fw /D2 /N3 /A01-01-%year% /P"%title% "

:: note use of CENTER justification in next line
FDATE /Ff /A02-01-%year% /J"C 79" /P"Note that " /S" begins Black History Month"

FDATE /Fe /J"L.50" /Vtitle        /Q"Valentine's day"
FDATE /Ff          /A02-14-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Presidents' Day"
FDATE /Fw /D2 /N3  /A02-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"St. Patrick's Day"
FDATE /Ff          /A03-17-%year% /P"%title% "

If (%LY%)==(1) FDATE /Fe /J"L.50" /Vtitle  /Q"Sadie Hawkins Day"
If (%LY%)==(1) FDATE /Ff /A02-29-%year%    /P"%title% "

:: ========== CALCULATE EASTER FOR 1900-2100 PERIOD====================
FDATE /f#comp /a%Year% /b1900 /va
If %a%==LT Goto Unknown
FDATE /f#comp /a%Year% /b2099 /va
If %a%==GT Goto Unknown
FDATE /f#idiv /a%Year% /b4 /va
FDATE /f#mod  /a%Year% /b19 /vb
FDATE /f#mult /a11 /b%b% /vc
FDATE /f#add /a204 /b-%c% /vc
FDATE /f#mod /a%c% /b30 /vc
FDATE /f#add /a%c% /b-13 /vd
FDATE /f#add /a%a% /b%d% /vd
FDATE /f#add /a%Year% /b%d% /vd
FDATE /f#mod /a%d% /b7 /vd
FDATE /f#add /a28 /b%c% /vn
FDATE /f#add /a%n% /b-%d% /vn
FDATE /ff /a3/%n%/%Year% /omm-dd-ccyy /vEaster
set a=|Set b=|Set d=|Set n=
echo.
:: ========== begin: DATES TIED TO EASTER==============================
FDATE /Fe /J"L.50" /Vtitle  /Q"Mardi Gras (Shrove Tuesday)"
FDATE /Fsub /N47 /A%easter% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle  /Q"Ash Wednesday (Lent begins)"
FDATE /Fsub /N46 /A%easter% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle  /Q"Palm Sunday"
FDATE /Fsub /N7  /A%easter% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle  /Q"Good Friday"
FDATE /Fsub /N2  /A%easter% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle  /Q"Easter"
FDATE /Ff        /A%easter% /P"%title% "

:Unknown
:: ==========    end: DATES TIED TO EASTER==============================

echo 
PAUSE
cls

FDATE /Fe /J"L.50" /Vtitle        /Q"Secretary's Day"
FDATE /Fw /D4 /N4  /A04-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Cinco de Mayo (Mexico)"
FDATE /Ff          /A05-05-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Mother's Day"
FDATE /Fw /D1 /N2  /A05-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Victoria Day (Canada)"
FDATE /Fw /D2 /N-1 /A05-24-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Memorial Day (observed)"
FDATE /FW /D2 /N-1 /A05-31-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle                        /Q"Ascension Day"
If Not (%easter%)==() FDATE /Fadd /N39 /A%easter% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle                        /Q"Pentecost"
If Not (%easter%)==() FDATE /Fadd /N49 /A%easter% /P"%title% "

If Not (%easter%)==() Echo.

FDATE /Fe /J"L.50" /Vtitle  /Q"Flag Day"
FDATE /Ff /A06-14-%year%    /P"%title% "

:: ----- anniversary of Bloom's Day, June 16, 1904 ------------------
:: Here's a way to show an anniversary or event that you want to note.
:: Thanks to L. Schliesser for the algorithm.
:: ------------------------------------------------------------------
FDATE /F#dIf /A%year% /B1904 /vann

FDATE /Fe /J"L.50" /Vtitle       /Q"Bloom's Day (%ann%th anniversary)"
FDATE /Ff /A06-16-%year%         /P"%title% "
set ann=
:: ---------------end bloom's day --------------------------------------

FDATE /Fe /J"L.50" /Vtitle      /Q"Father's Day"
FDATE /Ff /A07-01-%year%        /P"%title% "

FDATE /Fe /J"L.50" /Vtitle      /Q"Independence Day (USA)"
FDATE /Ff /A07-04-%year%        /P"%title% "

FDATE /Fe /J"L.50" /Vtitle      /Q"Bastille Day (France)"
FDATE /Ff /A07-14-%year%        /P"%title% "

:: Echo  
:: PAUSE
:: CLS

FDATE /Fe /J"L.50" /Vtitle       /Q"Labor Day"
FDATE /Fw /D2 /N1 /A09-01-%year% /P"%title% "


:: ---- begin ------- note a particular day in a particular year
:: This technique is useful for noting special events:
:: 21st birthdays, 50th wedding anniversaries, etc.

FDATE /Fe /J"L.50" /Vtitle  /Q"500th anniversary of Columbus's discovery"
If (%year%)==(1992) FDATE /Ff /A10-12-%year% /P"%title% "
:: ----   end -------- note a particular day in a particular year

FDATE /Fe /J"L.50" /Vtitle        /Q"Columbus Day (observed)"
FDATE /Fw /D2 /N2  /A10-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Thanksgiving Day (Canada)"
FDATE /Fw /D2 /N2  /A10-01-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Veteran's Day"
FDATE /Ff          /A11-11-%year% /P"%title% "

:: Fourth Thursday in November
FDATE /Fe /J"L.50" /Vtitle        /Q"Thanksgiving Day (USA)"
FDATE /Fw /D5 /N4  /A11-01-%year% /P"%title% "


FDATE /Fe /J"L.50" /Vtitle        /Q"First Sunday in Advent"
FDATE /Fw /D1 /N-4 /A12-24-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"Christmas"
FDATE /Ff          /A12-25-%year% /P"%title% "

FDATE /Fe /J"L.50" /Vtitle        /Q"New Year's Day"
FDATE /fadd /N1    /A12-31-%year% /P"%title% "

echo 
:Endit
set year=
set FDATE=
set easter=
set title=
set LY=
